<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>propclass/cameras/tracking.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">propclass/cameras/tracking.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2001 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PF_TRACKINGCAMERA__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_TRACKINGCAMERA__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;propclass/delegcam.h&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">struct </span>iPcTrackingCamera : <span class="keyword">public</span> <span class="keyword">virtual</span> iPcCameraMode
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__scf.html#ga711056cbf220f268640935926c404ba5">SCF_INTERFACE</a> (iPcTrackingCamera, 0, 0, 1);
<a name="l00028"></a>00028 
<a name="l00029"></a>00029   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> DecideState () = 0;
<a name="l00030"></a>00030   <span class="comment">// position, target, up</span>
<a name="l00031"></a>00031   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;GetPosition () = 0;
<a name="l00032"></a>00032   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;GetTarget () = 0;
<a name="l00033"></a>00033   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;GetUp () = 0;
<a name="l00034"></a>00034 
<a name="l00039"></a>00039   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> ResetCamera () = 0;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   <span class="keyword">enum</span> TargetState
<a name="l00042"></a>00042   {
<a name="l00043"></a>00043     TARGET_BASE = 0,
<a name="l00044"></a>00044     TARGET_OBJ,
<a name="l00045"></a>00045     TARGET_NONE
<a name="l00046"></a>00046   };
<a name="l00047"></a>00047 
<a name="l00052"></a>00052   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetTargetEntity (<span class="keyword">const</span> <span class="keywordtype">char</span>* name) = 0;
<a name="l00053"></a>00053 
<a name="l00060"></a>00060   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTargetState (TargetState targetstate) = 0;
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">virtual</span> TargetState GetTargetState () = 0;
<a name="l00066"></a>00066 
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTargetYOffset (<span class="keywordtype">float</span> targetyoffset) = 0;
<a name="l00072"></a>00072 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetTargetYOffset () <span class="keyword">const</span> = 0;
<a name="l00078"></a>00078 
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTargetInterpolationTime (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> t) = 0;
<a name="l00084"></a>00084 
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> GetTargetInterpolationTime () <span class="keyword">const</span> = 0;
<a name="l00090"></a>00090 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetOffsetAngle (<span class="keywordtype">float</span> angle) = 0;
<a name="l00096"></a>00096 
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetOffsetAngle () <span class="keyword">const</span> = 0;
<a name="l00102"></a>00102 
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetOffsetDistance (<span class="keywordtype">float</span> dist) = 0;
<a name="l00108"></a>00108 
<a name="l00113"></a>00113   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetOffsetDistance () <span class="keyword">const</span> = 0;
<a name="l00114"></a>00114 
<a name="l00118"></a>00118   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetFollowSpringLength (<span class="keywordtype">float</span> slen) = 0;
<a name="l00119"></a>00119 
<a name="l00123"></a>00123   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetFollowSpringLength () <span class="keyword">const</span> = 0;
<a name="l00124"></a>00124 
<a name="l00129"></a>00129   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetFollowMinimumSpringFactor (<span class="keywordtype">float</span> smin) = 0;
<a name="l00130"></a>00130 
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetFollowMinimumSpringFactor () <span class="keyword">const</span> = 0;
<a name="l00135"></a>00135 
<a name="l00140"></a>00140   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetPanDirection (<span class="keywordtype">float</span> pandir) = 0;
<a name="l00141"></a>00141 
<a name="l00145"></a>00145   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetPanDirection () <span class="keyword">const</span> = 0;
<a name="l00146"></a>00146 
<a name="l00150"></a>00150   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetPanSpeed (<span class="keywordtype">float</span> panspeed) = 0;
<a name="l00151"></a>00151 
<a name="l00155"></a>00155   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetPanSpeed () <span class="keyword">const</span> = 0;
<a name="l00156"></a>00156 
<a name="l00160"></a>00160   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetPanAcceleration (<span class="keywordtype">float</span> paccel) = 0;
<a name="l00161"></a>00161 
<a name="l00165"></a>00165   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetPanAcceleration () <span class="keyword">const</span> = 0;
<a name="l00166"></a>00166 
<a name="l00171"></a>00171   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTiltDirection (<span class="keywordtype">float</span> tdir) = 0;
<a name="l00172"></a>00172 
<a name="l00176"></a>00176   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetTiltDirection () <span class="keyword">const</span> = 0;
<a name="l00177"></a>00177 
<a name="l00181"></a>00181   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTiltSpeed (<span class="keywordtype">float</span> tiltspeed) = 0;
<a name="l00182"></a>00182 
<a name="l00186"></a>00186   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetTiltSpeed () <span class="keyword">const</span> = 0;
<a name="l00187"></a>00187 
<a name="l00191"></a>00191   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTiltAcceleration (<span class="keywordtype">float</span> paccel) = 0;
<a name="l00192"></a>00192 
<a name="l00196"></a>00196   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetTiltAcceleration () <span class="keyword">const</span> = 0;
<a name="l00197"></a>00197 
<a name="l00201"></a>00201   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetZoomOutCorrectionSpeed (<span class="keywordtype">float</span> zoomspeed) = 0;
<a name="l00202"></a>00202 
<a name="l00206"></a>00206   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetZoomOutCorrectionSpeed () <span class="keyword">const</span> = 0;
<a name="l00207"></a>00207 };
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 <span class="preprocessor">#endif // __CEL_PF_TRACKINGCAMERA__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
